var $ = jQuery;

var JapkinWP = {
	Init: function() {
		JapkinWP.BindElements();
	},
	
	BindElements: function() {
		$('#japkin_email, #japkin_password').bind( 'keypress', function( e ) {
			if ( e.keyCode == 13 ) {
				$('.button.login').click();
			}
		});
		
		$('.button.login').click( function() {
			var email = $.trim( $('#japkin_email').val() );
			var password = $.trim( $('#japkin_password').val() );
			
			JapkinWP.ShowMessage( '' );
			
			if ( email == '' ) {
				JapkinWP.ShowMessage( 'Email address is required.', 'fail' );
			} else if ( !JapkinWP.ValidEmail( email ) ) {
				JapkinWP.ShowMessage( 'Invalid email address format.', 'fail' );
			} else if ( password == '' ) {
				JapkinWP.ShowMessage( 'Password is required.', 'fail' );
			} else {
				JapkinWP.ShowMessage( 'Logging in...' );
				$.ajax({
					type: 'post',
					url: 'http://www.japkin.com/websites/webservice.php',
					data: {
						method: 'login',
						email: email,
						password: password,
						domain: window.location.hostname
					},
					dataType: 'jsonp',
					success: function( data ) {
						if ( data.Status == 500 ) {
							JapkinWP.ShowMessage( data.Message, 'fail' );
						} else if ( data.Status == 404 ) {
							JapkinWP.ShowMessage( 'Site not found. Please go to your <a href="http://www.japkin.com/websites/my-settings/" target="_blank">Settings Page</a>.', 'fail' );
						} else {
							JapkinWP.ShowMessage( '' );
							
							JapkinWP.SaveOptions({
								'id' : data.Params.id,
								'email' : data.Params.email,
								'key' : data.Params.key
							});
						}
					} 
				});
			}
		});
		
		$('.button.change-user').click( function() {
			JapkinWP.ClearOptions();
		});
	},
	
	SaveOptions: function( options ) {
		JapkinWP.ShowMessage( 'Saving your settings...' );
		$.ajax({
			type: 'post',
			url: ajaxurl,
			data: {
				action: 'japkin_options',
				id: options.id,
				email: options.email,
				key: options.key
			},
			dataType: 'json',
			success: function( data ) {
				window.location.reload();
			}
		});
	},
	
	ClearOptions: function() {
		JapkinWP.ShowMessage( 'Clearing plugin cache...' );
		$.ajax({
			type: 'post',
			url: ajaxurl,
			data: {
				action: 'japkin_options',
				method: 'clear'
			},
			dataType: 'json',
			success: function( data ) {
				window.location.reload();
			}
		});
	},
	
	ShowMessage: function( message, type ) {
		if ( typeof( type ) == 'undefined' ) { var type = ''; }
		
		if ( message != '' ) {
			$('#japkin_settings .message').addClass( type ).html( message );
		} else {
			$('#japkin_settings .message').attr( 'class', 'message' ).html( message );
		}
	},
	
	ValidEmail: function( email ) {
		var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
		return regex.test( email );
	}
};

$(document).ready( function() {
	JapkinWP.Init();
});